
#include "heap.h"
#include "assert.h"
#include "config_app.h"

#ifndef HEAP_SIZE
    #error "The size of heap is not defined. Do it in your config_app.h."
#endif /* HEAP_SIZE */


static uint8_t _pool[ HEAP_SIZE ];
static uint8_t * _pool_pointer = _pool;

void * heap_alloc( size_t size )
{
    uint8_t * result = NULL;
    
    /* Check the heap size */
    ASSERT_RULE( ( _pool_pointer - _pool + size ) <= HEAP_SIZE, "failed - heap size exceeded" );

    result = _pool_pointer;
    _pool_pointer += alignment_ceil( size, MCU_ALIGNMENT_SIZE );

    return result;
}

void heap_clear( void )
{
    memset( _pool, 0x00, sizeof( _pool ) );
    _pool_pointer = _pool;
}
